#include <stdlib.h>
#include <stdio.h>

/* Riempie un array di interi di lunghezza 'len' puntato da 'a' con il
   valore 'val'*/

void fillArray(int* a, int len, int val)
{
  int i;
  for(i=0; i<len; i++)
    a[i]=val;
}


/* Riempie un insieme di array di interi di lunghezza 'arrayLength'
   con il valore 'val'.  L'insieme e' rappresentato per mezzo di un
   array di puntatori la cui lunghezza e' 'setSize'.
*/

void fillArraySet(int** a, int setSize, int arrayLength, int val)
{
  int i;
  for(i=0; i<setSize; i++)
    fillArray(a[i], arrayLength, val);
}

/* Riempie un insieme di array di interi di lunghezza 'arrayLength'
   con il valore 'val'.  L'insieme e' rappresentato per mezzo di un
   array di puntatori la cui lunghezza e' 'setSize'.
   Il 100-esimo elemento dell'insieme viene annullato.
*/

void fillArraySet100(int** a, int setSize, int arrayLength, int val)
{
  int i;
  for(i=0; i<setSize; i++)
    {

    if (i==100)
      a[i]=NULL;
    else
      fillArray(a[i], arrayLength, val);

    }
}



/* Crea un insieme di array di interi di lunghezza 'arrayLength'.  L'insieme
   e' rappresentato per mezzo di un array di puntatori la cui
   lunghezza e' 'setSize'. Viene ritornato un puntatore all'array che
   rappresenta l'insieme.
*/

int** createArraySet(int setSize, int arrayLength)
{
  int i;
  int** a= (int**) malloc(sizeof(int*)*setSize);
  for(i=0; i<setSize; i++)
    a[i]= (int*) malloc(sizeof(int)*arrayLength);
  return a;
}

/* Stampa un insieme di taglia 'setSize' di array di interi di
   lunghezza 'arrayLength'. */

void printArraySet(int** a, int setSize, int arrayLength)
{
  int i,j;
  for(i=0; i<setSize; i++)
    {
    for(j=0; j<arrayLength; j++)
      printf("%d ",a[i][j]);
    printf("\n");
    }
}

int main()
{
  const int setSize=120;
  const int arrayLength=20;

  int** s;

  printf("creo l'insieme di array, senza inizializzarlo\n");
  s=createArraySet(setSize,arrayLength);

  printf("riempio l'insieme di array di zeri\n");
  fillArraySet(s,setSize,arrayLength,0);

  printf("stampo l'insieme di array\n");
  printArraySet(s,setSize,arrayLength);

  printf("riempio l'insieme di array con 1 usando fillArraySet100()\n");
  fillArraySet100(s,setSize,arrayLength,1);

  printf("stampo l'insieme di array\n");
  printArraySet(s,setSize,arrayLength);

  return 0;  
}
